<?php
/*---------------------------------------------------------------*/
/*
    Titre : Crer une vignette avec GD en se basant sur le type d'image                                                   
                                                                                                                          
    URL   : https://phpsources.net/code_s.php?id=554
    Date dition     : 13 Jan 2010                                                                                        
*/
/*---------------------------------------------------------------*/


    // image source
    $source_image = 'image1.jpg';

    // maximum hauteur
    $thumb_height = 40;

    // prefix de l'image
    $thumb_prefix = 'thumb_';

    // la qualit de l'image
    $quality = 100;

    // regarde l'existence du fichier
    if(!file_exists($source_image))  {
        echo 'No file found';
    }
    else
    {
        // types supports
       $supported_types = array(1, 2, 3, 7);

        // prend des infos de l'image
        list($width_orig, $height_orig, $image_type) = getimagesize(
$source_image);

        // regarde si le type est support
        if(!in_array($image_type, $supported_types))
        {
            echo 'Unsupported Image Type: ' . $image_type;
        }
        else
        {

            // prend le nom du fichier
            $path_parts = pathinfo($source_image);
            $filename = $path_parts['filename'];

            // calcul le ration
            $aspect_ratio = (float) $width_orig / $height_orig;

            // calcul l'image sur la base hauteur
            $thumb_width = round($thumb_height * $aspect_ratio);
 
            
// imagecreatefromstring va automatiquement detecter le type de l'image
            $source = imagecreatefromstring(file_get_contents($source_image));

            // creer le canvas
            $thumb = imagecreatetruecolor($thumb_width, $thumb_height);

            // map l'image
            imagecopyresampled($thumb, $source, 0, 0, 0, 0, $thumb_width, 
$thumb_height, $width_orig, $height_orig);
            // detruit la source
            imagedestroy($source);
 
            // ecrit l'image
            switch ( $image_type )
            {
                case 1:
                    imagegif($im, $fileName);
                    $thumbnail = $thumb_prefix.$filename . '.gif';
                    break;

                case 2:
                    $thumbnail = $thumb_prefix.$filename . '.jpg';
                    imagejpeg($thumb, $thumbnail, $quality);
                    break;

                case 3:
                    imagepng($im, $fileName);
                    $thumbnail = $thumb_prefix.$filename . '.png';
                    break;

                case 7:
                    imagewbmp($im, $fileName);
                    $thumbnail = $thumb_prefix.$filename . '.bmp';
                    break;
            }
        }
    }
?>